import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { DictionaryData, DictionaryDataParam } from './model';
import {SERVER_API_URL} from "@/utils/server";

/**
 * 分页查询字典数据
 */
export async function pageDictionaryData(params: DictionaryDataParam) {
  const res = await request.get<ApiResult<PageResult<DictionaryData>>>(
    SERVER_API_URL + '/system/dict-data/page',
    { params }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询字典数据列表
 */
export async function listDictionaryData(params: DictionaryDataParam) {
  const res = await request.get<ApiResult<DictionaryData[]>>(
    SERVER_API_URL + '/system/dict-data',
    { params }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加字典数据
 */
export async function addDictionaryData(data: DictionaryData) {
  const res = await request.post<ApiResult<unknown>>(
    SERVER_API_URL + '/system/dict-data',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改字典数据
 */
export async function updateDictionaryData(data: DictionaryData) {
  const res = await request.put<ApiResult<unknown>>(
    SERVER_API_URL + '/system/dict-data',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除字典数据
 */
export async function removeDictionaryData(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    SERVER_API_URL + '/system/dict-data/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除字典数据
 */
export async function removeDictionaryDataBatch(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    SERVER_API_URL + '/system/dict-data/batch',
    { data }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}
